/*

This code was written by Zdrapek
-Printables: https://www.printables.com/@Zdrapek
-instructables: https://www.instructables.com/member/Zdrapek
-Discord: zdrapek.ind

Last updated: 14.02.2024

*/



#include <Adafruit_NeoPixel.h>
#include <Servo.h>
#include <SoftwareSerial.h>

SoftwareSerial HC12(2,3); 

#define LED_PIN   11
#define LED_COUNT 15

// Declare our NeoPixel strip object:
Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);


Servo servo;
Servo ESC;

int servo_pin = 5;
int esc_pin = 6;
int light_rear_pin = 7;
int light_front_pin = 4;
String fix_pin = "A0";

int gear = 1;
int servo_angle = 90;
int servo_max = 150;
int servo_min = 30;
int sservo = 90;
int fix = 0;
int reverse = 1;
int set_speed = 0;
int speed = 0;
int rel_speed = 0;
int light_front = 0;
int light_rear = 0;

int servoo = 90;


void setup() {

  pinMode(A0, INPUT);

  pinMode(10, OUTPUT);
  pinMode(13, OUTPUT);
  
  strip.begin();  
  strip.show();           
  strip.setBrightness(50);
  strip.clear();

  colorWipe(strip.Color(0,   200,   255), 50);

  Serial.begin(9600);
   HC12.begin(9600);
  delay(250);

servo.attach(servo_pin);
ESC.attach(6, 1000, 2000);
ESC.write(0);

ESC.write(10);
servo.write(90 + fix);
digitalWrite(light_front_pin, HIGH);
digitalWrite(light_rear_pin, HIGH);
delay(250);
ESC.write(0);
servo.write(servo_max + fix);
digitalWrite(light_front_pin, LOW);
digitalWrite(light_rear_pin, LOW);
delay(250);
servo.write(90 + fix);
digitalWrite(light_front_pin, HIGH);
digitalWrite(light_rear_pin, HIGH);
delay(250);
servo.write(servo_min + fix);
digitalWrite(light_front_pin, LOW);
digitalWrite(light_rear_pin, LOW);
delay(250);
servo.write(90 + fix);

ESC.write(10);
delay(10);
ESC.write(0);

delay(2500);

}
 

char cmd[100];
byte cmdIndex;




void exeCmd() {


  if (cmd[0] == 's') {
    unsigned int serv = atof(cmd + 2);
    sservo = serv;
    
  }

  if (cmd[0] == 'm') {
    unsigned int moto = atof(cmd + 2);


    speed = map(moto, 0, 100, 0, 30);

    
  }

  if (cmd[0] == 'l') {
    unsigned int fron = atof(cmd + 2);
    light_front = fron;
    light_rear = fron;
  }


  if (cmd[0] == 'g') {
    unsigned int gea = atof(cmd + 2);
    gear = gea;
  }

  if (cmd[0] == 'b') {
    unsigned int buz = atof(cmd + 2);
    if(buz == 1){
      digitalWrite(10, HIGH);
    }else{
      digitalWrite(10, LOW);
    }
  }



}


void loop() {
/*
while (HC12.available()) {
    Serial.write(HC12.read());
  }
  while (Serial.available()) { 
    HC12.write(Serial.read());
  }
  */

 if (Serial.available() > 0){
    char c = (char)Serial.read();
    if (c == '\n') {
      cmd[cmdIndex] = 0;
      exeCmd();
      cmdIndex = 0;
    } else {
      cmd[cmdIndex] = c;
      if (cmdIndex < 99) cmdIndex++;
    }
  }


fix = map(analogRead(A0), 0, 1023, -60, 60);



if(gear >= 0){
  ESC.write(speed * gear);
  digitalWrite(13, LOW);
}else{
  ESC.write(speed * abs(gear));
  digitalWrite(13, HIGH);
}


digitalWrite(light_front_pin, light_front);
digitalWrite(light_rear_pin, light_rear);

servo.write(sservo + fix);


}



void colorWipe(uint32_t color, int wait) {
  for(int i=0; i<strip.numPixels(); i++) { // For each pixel in strip...
    strip.setPixelColor(i, color);         //  Set pixel's color (in RAM)
    strip.show();                          //  Update strip to match
    delay(wait);                           //  Pause for a moment
  }
}
